/**
 * Adds Button SDK event listeners for JS-based navigation. Wraps methods to update back stack in
 * order to notify the Button SDK then invokes original method.
 *
 * @see com.usebutton.sdk.internal.web.ButtonJavascriptInterface.java
 */

var btn_wrap = function(type) {
    var orig = history[type];
    return function() {
        var rv = orig.apply(this, arguments);
        var e = new Event(type);
        e.arguments = arguments;
        window.dispatchEvent(e);
        return rv;
    };
};

history.pushState = btn_wrap('pushState'), history.replaceState = btn_wrap('replaceState');

window.addEventListener('popstate', function(e) {
    ButtonSdk.onNavigation();
});

window.addEventListener('pushState', function(e) {
    ButtonSdk.onNavigation();
});

window.addEventListener('replaceState', function(e) {
    ButtonSdk.onNavigation();
});
